/*++Target.java+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* Log:
 * see eof
 */


package  edu.washington.cac.calendar.cap;


import  edu.washington.cac.calendar.icalendar.TextProp;
/*???
import  edu.washington.cac.calendar.icalendar.URIProp;
*/


/**
 * CAP TARGET property.
 *
 *<PRE>	<!-- for alignment purposes -->&nbsp;
 * Spec:
 *   section:	8.26 [CAP-09]
 *   occurs:	1 (CMD component)???
 *   datatypes:	URI (1)
 *   default:	---
 *   allowed:	cap URI
 *   params:	xparam (0+)
 *</PRE>
 *
 * @author  slh
 * @version  0.10 2003/02/11 slh
 */
public
class  Target
//???
extends  TextProp
{

/*----------------------------------------------------------------------------
 *						Constructors
 *--------------------------------------------------------------------------*/

  /**
   * Create a TARGET property, unset.
   */
  public
  Target  (		)
  {
    super( Names.strProp_Target );
/*???
    m_strScheme = mc_strScheme;
*/
  }


  /**
   * Create a TARGET property set to supplied value.
   */
  public
  Target  (String	strValue	)
  {
    super( Names.strProp_Target , strValue );
/*???
    m_strScheme = mc_strScheme;
*/
  }


/*----------------------------------------------------------------------------
 *						Class Public Data
 *--------------------------------------------------------------------------*/

/*???
  static final public String	mc_strScheme	= "cap";
*/


/*----------------------------------------------------------------------------
 *						Main
 *--------------------------------------------------------------------------*/

  static public
  void  main  (String	args[]	)
  {
    Target	target		= new Target(  );

    try {
      /*void*/System.out.println( target );

      /*void*/target.set( "cap://slh.net:666/alocation" );
      /*void*/System.out.println( target );

      /*void*/System.out.println(
		"NOTE: should throw IllegalArgumentException:" );
      /*void*/target.set( "http://slh.net:666/alocation" );
      /*void*/System.out.println( target );
    } catch (Exception	e	) {
      /*void*/System.out.println( "\t" + e );
    }
  }

}


/* Log:
 *  0.10  2003/02/11  slh
 *        (new year, new version...)
 *        derive from TextProp (instead of URIProp)
 *          (until relcalid issue resolved)
 *  0.00  2002/12/03  slh
 *        create from Decreed
 */
/*--Target.java-------------------------------------------------------------*/
