// Java

package edu.washington.cac.myuw.servlet;

import java.io.IOException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Calendar;
import java.util.Calendar;

/** A object to handle creating a new version of a file every month

  @author Greg Barnes
  @version 1.0
*/
public class MonthlyPrintStream {
  public PrintStream getMonthlyPrintStream(String baseName) {
    Calendar cal = new java.util.GregorianCalendar();
    int curmonth = cal.get(Calendar.MONTH) + 1; 

      // The following switches to a new log file each month
    String filename = baseName + cal.get(Calendar.YEAR) 
      + (curmonth <10 
        ? "0" + Integer.toString(curmonth) : Integer.toString(curmonth))
      + (edu.washington.cac.myuw.test.TestMode.isTestMode() ? ".test" : "");

    try {
      // the second argument opens the file for appending
      return new PrintStream(new FileOutputStream(filename, true));
    } catch (IOException e) {
      System.err.println("MonthlyPrintStream: couldn't open file " + 
          filename);
      return System.err;
    }
  }
}
