//java
package edu.washington.cac.myuw.test;

import java.util.Properties;
import edu.washington.cac.myuw.servlet.LogFactory;
/**
    This class is responsible for loading the myuw.stresstest file and 
    setup the value of the witch.
    @version 2.0 2002/4/5 
    @author fanglin
*/

public class TestMode {

  private TestMode () { }

  /** Location of the properties file */
  private static final String PROPERTIES_FILE =
    "/properties/dbclient/stresstest.properties";

  /** Object to hold properties */
  private static Properties properties = new Properties();

  /** Load properties file */

  static {
    try
      {   
	properties.load(TestMode.class.getResourceAsStream(PROPERTIES_FILE));
      }
    catch(Exception e)
      {} // doesn't really matter; isTestMode handles this case fine
  }
  
  public static boolean isTestMode ()
  {
    try {
      return new Boolean( properties.getProperty("ONTEST")).booleanValue();
    } catch (Exception e) {
      return false;
    }
  }

  public static void main(String args[]) {
    System.out.println("isTestMode: " + TestMode.isTestMode());
  }

}
