package pubevents;

import java.sql.SQLException;

/** The base class of the non-admin UWCal pubevents servlets. 

   @version 1.1
   @author Greg Barnes
*/
public abstract class NotAdminServlet extends PubEventsEntryServlet 
{
  /** The URL of the login page for non-administrators */
  protected static final String START_URL = PEDefaults.LOGIN_URL;

  /** @return the URL of the login page */
  protected String getStartURL() 
  {
    return START_URL;
  }

  /** @return the name of the 'not authorized' file for this servlet */
  protected String getNotAuthorizedFile()
  {
    return PEDefaults.NOT_YET_AUTHORIZED;
  }

  /**
    @return Whether a user is authorized to log in
    @param uid User to check
    @exception SQLException If there's a problem checking the database
   */
  protected boolean authorized(String uid) throws SQLException
  {
    return super.pubAuthorized(uid);
  }
}
