/*++ExportPage.java+++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* Log:
 * see eof
 */


package  uwcal.export;


import  java.io.PrintWriter;
import  java.io.IOException;
import  java.util.Iterator;
import  java.util.ListIterator;
import  java.util.Vector;
import  javax.servlet.ServletConfig;
import  javax.servlet.ServletException;
import  javax.servlet.http.HttpServletRequest;
import  javax.servlet.http.HttpServletResponse;

import  edu.washington.cac.myuw.servlet.Log;
import  edu.washington.cac.myuw.servlet.BlankParameterException;
import  edu.washington.cac.myuw.servlet.NullParameterException;
import  edu.washington.cac.myuw.servlet.ServletSupport;

import  uwcal.CalServlet;
import  uwcal.CalSession;
import  uwcal.out.CalMessageMaker;
import  uwcal.out.Page;
import  edu.washington.cac.calendar.CalLogFactory;
import  edu.washington.cac.calendar.CalParameter;
import  edu.washington.cac.calendar.MyCalendar;
import  edu.washington.cac.calendar.data.EventsI;
import  edu.washington.cac.calendar.data.PersonalEvents;
import  edu.washington.cac.calendar.data.User;
import  edu.washington.cac.calendar.data.NoSuchItemException;
import  edu.washington.cac.calendar.db.Caldata;
import  edu.washington.cac.calendar.filter.Calendar;
import  edu.washington.cac.calendar.filter.FilteredEvents;
import  edu.washington.cac.calendar.filter.PublicCalendars;
import  edu.washington.cac.calendar.icalendar.ICalendar;
import  edu.washington.cac.calendar.icalendar.Utilities;
import  edu.washington.cac.calendar.icalendar.xml.RootXMLer;
import  edu.washington.cac.calendar.uwical.UWICal;
import  edu.washington.cac.calendar.uwical.text.RootFormatter;


/**
 * Export a public calendar.
 *
 * @author  slh
 * @version  0.02 2003/10/14 slh
 */
public
class  ExportPage
extends  CalServlet
{

/*----------------------------------------------------------------------------
 *						Object Public Methods
 *--------------------------------------------------------------------------*/

  public
  void  init  (ServletConfig	sc	)
  throws  ServletException
  {
    super.init( sc );

    String	strMethod	= "init";

    strModule = this.getClass(  ).getName(  );
    id = strModule;

    /*(void)*/createLog(  ).log( strModule , strMethod , Log.LOGTYPE_NOTICE ,
				 "Starting servlet..." );
  }


  public
  void  doGet  (HttpServletRequest	hsreq	,
		HttpServletResponse	hsres	)
  throws  ServletException, IOException
  {
    String		strMethod	= "doGet";

    ServletSupport	ss;
    CalSession		cs;
    User		user		= null;
    PrintWriter		pw;
    Log			log;
    CalParameter	cp;
    String		astrValue[];
    String		strName		= Config.strDefault_Name;
    String		strBegTime	= Config.getToday(  );
    String		strEndTime	= Config.getToday(  );
    String		uid;
    boolean		bMime		= Config.bDefault_MIME;
    boolean		bQP		= Config.bDefault_QP;
    int			Format		= Config.iDefault_Format;
    int			Error		= Config.Error_NoError;

    ss = new ServletSupport( strModule ,
			     new CalMessageMaker(  ) , new CalLogFactory(  ) ,
			     true );

    try {
      cs = new CalSession( hsreq );
      /*void*/ss.setLog( cs.getLog(  ) );
      log = cs.getLog(  );
      uid = cs.verify(  );
      user = new User(uid);

     /* Get parameters */
      try {
	cp = new CalParameter( hsreq );
        /*Note: get least error prone parameters first*/
        Error = Integer.parseInt( cp.getPValue( Config.strParamName_Error ) );
        Format = Config.stringToFormat(
			cp.getPValue( Config.strParamName_Format ) );
        bMime= null != cp.getPValue( Config.strParamName_Mime , false );
        bQP = null != cp.getPValue( Config.strParamName_QP , false );
	strName = cp.getPValue( Config.strParamName_Name );
        strBegTime = Config.paramsToDateCode(
			cp , Config.strParamName_Begin );
        strEndTime = Config.paramsToDateCode( cp , Config.strParamName_End );
      } catch (Exception	e	) {
	;	// ignore any errors here
      }

     /* Setup output */
      pw = hsres.getWriter(  );

      hsres.setContentType( Config.strContentType_html );

      /*void*/genPageTop(
		pw , mc_strNormalTitle , mc_strNormalHeading ,
		Error == Config.Error_NoError
			? null : Config.errorToString( Error ) );

     /* Output form */
      /*void*/pw.print(
		"<p><form action='" + mc_strURL_Self + "' method='post'>" +
		"<table>\n" );
      astrValue = getCalendarList(  );
      /*void*/HTML.genSelectItem(
		pw ,
		Config.strParamName_Name , Config.strParamLabel_Name ,
		Config.strParamAccess_Name , Config.strParamDescr_Name ,
		astrValue , astrValue , strName , true );
      /*void*/HTML.genDateItem( 
		pw ,
		Config.strParamName_Begin , Config.strParamLabel_Begin ,
		Config.strParamAccess_Begin , Config.strParamDescr_Begin ,
		strBegTime , true );
      /*void*/HTML.genDateItem( 
		pw ,
		Config.strParamName_End , Config.strParamLabel_End ,
		Config.strParamAccess_End , Config.strParamDescr_End ,
		strEndTime , true );
      /*void*/HTML.genRadioGroupItem(
		pw ,
		Config.strParamName_Format , Config.strParamLabel_Format ,
		Config.strParamAccess_Format , Config.strParamDescr_Format ,
		Config.astrLabel_Format , Config.astrValue_Format ,
		Config.formatToString( Format ) , true );
      HTML.genCheckboxItem(
		pw ,
		Config.strParamName_Mime , Config.strParamLabel_Mime ,
		Config.strParamAccess_Mime , Config.strParamDescr_Mime ,
		bMime , true );
      HTML.genCheckboxItem(
		pw ,
		Config.strParamName_QP , Config.strParamLabel_QP ,
		Config.strParamAccess_QP , Config.strParamDescr_QP ,
		bQP , true );
      /*void*/pw.print( "<tr><td>\n" );
      /*void*/pw.print( "<input type='submit'" +
			" name='" + Config.strParamName_Retrieve + "'" +
			" value='" + Config.strParamLabel_Retrieve + "'>\n" );
      /*void*/pw.print( "</td></tr></table></form></p>\n" );

      /*void*/genPageBottom( pw , user.getNameDB(  ) );
    } catch (Throwable	e	) {
      ss.handleException( e , hsres );
    } finally {
      ss.done(  );
    }
  }


  public
  void  doPost  (HttpServletRequest	hsreq	,
		 HttpServletResponse	hsres	)
  throws  ServletException, IOException
  {
    String		strMethod	= "doPost";

    ServletSupport	ss;
    CalSession		cs;
    User		user		= null;
    PrintWriter		pw;
    ICalendar		icalendar;
    String		strCalendar;
    Log			log;
    CalParameter	cp;
    EventsI		eventsi;
    ListIterator	li;
    java.util.Calendar	jucalendarBeg, jucalendarEnd;
    String		strName		= null;
    String		strBegTime	= null;
    String		strEndTime	= null;
    String		uid;
    int			Format		= Config.Format_None;
    boolean		bMime		= false;
    boolean		bQP		= false;
    int			Error		= Config.Error_NoError;

    ss = new ServletSupport( strModule ,
			     new CalMessageMaker(  ) , new CalLogFactory(  ) ,
			     true );

    try {
      cs = new CalSession( hsreq );
      /*void*/ss.setLog( cs.getLog(  ) );
      log = cs.getLog(  );
      uid = cs.verify(  );
      user = new User(uid);

     /* Get Parameters */
      try {
	cp = new CalParameter( hsreq );
	/*Note: get least error prone parameters first*/
	bMime = null != cp.getPValue( Config.strParamName_Mime , false );
	bQP = null != cp.getPValue( Config.strParamName_QP , false );
	Format = Config.stringToFormat(
			cp.getPValue( Config.strParamName_Format ) );
	strName = cp.getPValue( Config.strParamName_Name );
	strBegTime = Config.paramsToDateCode(
			cp , Config.strParamName_Begin );
	strEndTime = Config.paramsToDateCode( cp , Config.strParamName_End );
      } catch (BlankParameterException	e	) {
	Error = Config.Error_MissingData;
      } catch (NullParameterException	e	) {
      /*NOTE: not clear when this happens;
	maybe when a user with an old browser on a slow connection
	cancels update.
	could also happen if there was no default for a radio group
	(e.g. format).
      */
	/*void*/log.log( strModule , strMethod , Log.LOGTYPE_WARNING ,
			 "a page parameter is null: aborting" );
	Error = Config.Error_NullParameter;
      }
      if (Error != Config.Error_NoError) {
	redirect( hsreq , hsres ,
		  strName , strBegTime , strEndTime , Format , bMime , bQP ,
		  Error );
	return;							/*RETURN*/
      }

      if (null == (jucalendarBeg = Config.getCheckCalendar( strBegTime )) ||
	  null == (jucalendarEnd = Config.getCheckCalendar( strEndTime )) ||
	  jucalendarBeg.after( jucalendarEnd )) {
	Error = Config.Error_InvalidData;
      }
      if (Error != Config.Error_NoError) {
	redirect( hsreq , hsres ,
		  strName , strBegTime , strEndTime , Format , bMime , bQP ,
		  Error );
	return;							/*RETURN*/
      }

      /*void*/log.log( strModule , strMethod , Log.LOGTYPE_NOTICE ,
		       "parameters: \"" + strName + "\" \"" + 
		       strBegTime + "\" \"" + strEndTime + "\" \"" +
		       Config.formatToString( Format ) + "\" " +
		       bMime + " " + bQP );

      pw = hsres.getWriter(  );

      try {
	hsres.setHeader( Config.strHeaderName_Pragma ,
			 Config.strHeaderValue_NoCache );

	if (strName.equals( mc_strMyCalendar )) {
	  eventsi = new PersonalEvents(user);
	} else {
	  eventsi = new FilteredEvents( PublicCalendars.getPublicCalendars(  ).
			getCalendar( strName ).getFilter(  ) );
	}
	li = eventsi.manyDaysEvents( new MyCalendar( strBegTime ) ,
				     new MyCalendar( strEndTime ) ).
			listIterator(  );
	icalendar = new UWICal( "C&C/UWCal Export" , "2.0" , li , eventsi );

	switch (Format) {
	case Config.Format_Text:
	  hsres.setContentType( Config.strContentType_text );
	  /*void*/pw.print( new RootFormatter( icalendar ).toString(  ) );
	  break;
	case Config.Format_XML:
	  hsres.setContentType( Config.strContentType_xml + ";" +
				Config.strContentTypeParamCharsetUTF8 );
	  /*void*/pw.print( new RootXMLer( icalendar ).toString(  ) );
	  break;
	case Config.Format_iCalendar:
	default:
	  strCalendar = Utilities.foldLines( icalendar );
	  if (!bMime) {
	    /*void*/hsres.setContentType( Config.strContentType_calendar );
	    /*void*/hsres.setHeader(
			Config.strHeaderName_ContentDisposition ,
			Config.strHeaderValue_ContentDisposition_ICalendar );
	    /*void*/pw.print( strCalendar );
	  } else {
	    /*void*/hsres.setContentType( Config.strContentType_mime );
	    /*void*/hsres.setHeader(
			Config.strHeaderName_ContentDisposition ,
			Config.strHeaderValue_ContentDisposition_MIME );
	    if (bQP) {
	      strCalendar = Utilities.encodeQP( strCalendar );
	    }
	    /*void*/pw.print( Utilities.encodeMime(
			strCalendar , Config.strCharset_UTF8 , bQP ,
			Config.strFilename_ICalendar ) );
	  }
	  break;
	}
      } catch (Exception        e       ) {
	/*void*/log.log( strModule , strMethod , Log.LOGTYPE_ERROR ,
			 e.getLocalizedMessage(  ) );

	hsres.setContentType( Config.strContentType_html );
	hsres.setHeader( Config.strHeaderName_Pragma ,
			 Config.strHeaderValue_NoCache );

	/*void*/genPageTop( pw ,
			    mc_strErrorTitle , mc_strErrorHeading ,
			    e.getLocalizedMessage(  ) );
	/*void*/genPageBottom( pw , user.getNameDB(  ) );
      }
    } catch (Throwable	e	) {
      ss.handleException( e , hsres );
    } finally {
      ss.done(  );
    }
  }


  public
  String  getServletInfo  (  )
  {
    return strModule + " servlet";
  }


/*----------------------------------------------------------------------------
 *						Class Protected Methods
 *--------------------------------------------------------------------------*/

  static protected
  void  redirect  (HttpServletRequest	hsreq		,
		   HttpServletResponse	hsres		,
		   String		strName		,
		   String		strBegTime	,
		   String		strEndTime	,
		   int			Format		,
		   boolean		bMime		,
		   boolean		bQP		,
		   int			Error		)
  throws  Exception
  {
    /*void*/sendRedirect( hsreq , hsres ,
			  mc_strURL_Self + "?" +
			  Config.strParamName_Error + "=" + Error +
			  "&" + Config.strParamName_Format + "=" + Format +
			  (!bMime ? "" :
			   "&" + Config.strParamName_Mime + "=on") +
			  (!bQP ? "" :
			   "&" + Config.strParamName_QP + "=on") +
			  (strEndTime == null ? "" :
			   ("&" + Config.strParamName_End + "="
			    + strEndTime)) +
			  (strBegTime == null ? "" :
			   ("&" + Config.strParamName_Begin +
			    "=" + strBegTime)) +
			  (strName == null ? "" :
			   ("&" + Config.strParamName_Name + "=" + strName)) ,
			  true , true );
  }


  static protected
  String[]  getCalendarList  (		)
  {
    Iterator	iter;
    Calendar	calendar;
    Vector	vector;
    int		idx;
    String	astrName[];
    Vector	vMain		= new Vector(  );
    Vector	vDefault	= new Vector(  );
    Vector	vOther		= new Vector(  );

    for (iter = PublicCalendars.getPublicCalendars(  ).elements(  ) ;
	 iter.hasNext(  ) ; ) {
      calendar = (Calendar)iter.next(  );

      if (calendar.isTopLevel(  )) {
        vector = PublicCalendars.printableSubcalendars( calendar );
        if        (calendar.getId(  ) == PublicCalendars.MAIN_ID) {
	  /*Note: this clause will only end up being done once*/
          /*(void)*/vMain.addAll( vector );
        } else if (calendar.getId(  ) == PublicCalendars.DEFAULT_ID) {
	  /*Note: this clause will only end up being done once*/
          /*(void)*/vDefault.add( calendar );
          /*(void)*/vDefault.addAll( vector );
        } else {
          /*(void)*/vOther.add( calendar );
          /*(void)*/vOther.addAll( vector );
        }
      }
    }

    vector = new Vector(  );
    if (vDefault != null) {
      /*(void)*/vector.addAll( vDefault );
    }
    if (vMain != null) {
      /*(void)*/vector.addAll( vMain );
    }
    if (vOther != null) {
      /*(void)*/vector.addAll( vOther );
    }

    astrName = new String[vector.size(  ) + 1];

    astrName[0] = mc_strMyCalendar;
    for (idx = 0 ; idx < vector.size(  ) ; idx++) {
      astrName[idx + 1] =
		((Calendar)vector.get( idx )).getFilter(  ).getName(  );
    }

    return astrName;
  }


  static protected
  void  genPageTop  (PrintWriter	pw		,
		     String		strTitle	,
		     String		strHeading	,
		     String		strError	)
  {
    /*void*/pw.print( "<html>\n" +
		      "<head>\n" +
		      "<title>" + strTitle + "</title>\n" +
		      "</head>\n" +
		      "<body>\n" );
    /*void*/pw.println(Page.LOGO);
    /*void*/pw.print( "<h1>" + strHeading + "</h1>\n" );

    if (strError != null) {
      /*void*/pw.println( "<p><font color='red'><strong>" +
			  strError +
			  "</strong></font></p>" );
    }
  }


  static protected
  void  genPageBottom  (PrintWriter	pw	,
			String		strUser	)
  {
    /*void*/pw.println( "Logged in as: " + strUser );
    /*void*/pw.println( "<hr></hr>" );
    /*void*/pw.print( "<table width='100%' border='0'>" +
		      "<tr><td width='15%' align='center'>\n" +
		      "<a href='http://www.washington.edu'>" +
		      "<img src='/graphics/uwid.gif' alt='UW home'" +
		      " border='0' align='bottom' hspace='5'></a>\n" +
		      "</td><td valign='top'>\n" +
		      "<address>Computing & Communications<br>" +
		      "uwchelp@cac.washington.edu<br></address>\n" +
		      "</td></tr></table>\n" );
    /*void*/pw.print( "</body>\n" +
		      "</html>\n" );
  }


/*----------------------------------------------------------------------------
 *						Object Private Variables
 *--------------------------------------------------------------------------*/
  private  String	strModule	= null;


/*----------------------------------------------------------------------------
 *						Class Private Constants
 *--------------------------------------------------------------------------*/

 /* Misc */
  static private final  String	mc_strURL_Self		=
					"uwcal.export.ExportPage";

  static private final  String	mc_strMyCalendar	= "My Calendar";

 /* Display */
  static private final  String	mc_strNormalTitle	= "Export Form";
  static private final  String	mc_strNormalHeading	= "Export";
  static private final  String	mc_strErrorTitle	= "Export Error";
  static private final  String	mc_strErrorHeading	= "Export Error";

}


/* Note: update class header too */
/* Log:
 *  0.02  2003/10/13 - 2003/10/14  slh
 *        getCalendarList(): redo
 *        get defaults from Config
 *  0.01  2003/09/22, 2003/09/24  slh
 *        set Content-Disposition
 *        QP option
 *  0.00  2003/07/23, 2003/09/03  slh
 *        create from PublicEntriesPage
 */
/*--ExportPage.java---------------------------------------------------------*/
