// java

package uwcal.out;

import edu.washington.cac.calendar.CalParameter;
import edu.washington.cac.calendar.MyCalendar;
import edu.washington.cac.calendar.data.Sponsor;

/** A HelperPrinter for a sponsor
    @author Greg Barnes
    @version 1.1
  */
public class SponsorHelperPrinter extends HelperPrinter 
{
  Sponsor s;

  /** Get a new instance
    @param s Sponsor to print
    @param page Page this printer is a part of
   */
  SponsorHelperPrinter(Sponsor s, Page page) 
  {
    super(s, page);
    this.s = s;
  }

  /**
    Get a URL to edit the sponsor
    @param today The current day
    @param sid Session identifier
    @return a URL to edit the sponsor
   */
  public String editUrl(MyCalendar today, int sid) 
  {
    return EditSponsor.url(today, this.s, this.page, sid);
  }

  private static final String DELETE_SPONSOR_URL =
      WebResources.BASE_GET_URL + CalParameter.DELETESPONSOR_FUNC + 
      Util.DATE_PARAM;

  /**
    Get a URL to delete the sponsor
    @param today The current day
    @param sid Session identifier
    @return a URL to delete the sponsor
   */
  public String deleteUrl(MyCalendar today, int sid) 
  {
    return Util.makeUrl (DELETE_SPONSOR_URL, today, this.page,
                         Util.SPONSOR_ID_PARAM, this.s.getId(), sid);
  }

  public String cName() 
  {
    return DisplayText.SPONSOR;
  }
}
