// java

package uwcal.out.forms;

import org.apache.ecs.ElementContainer;

import edu.washington.cac.calendar.CalParameter;
import edu.washington.cac.calendar.MyCalendar;
import edu.washington.cac.calendar.data.Keyword;

import uwcal.out.Page;

/**
  A form to edit a keyword
  @author Greg Barnes
  @version 1.0
 */
public class EditKeywordForm extends KeywordForm 
{
  /** Create a new instance
    @param page Page this form is a part of
    @param k The keywords to be edited
   */
  public EditKeywordForm(Page page, Keyword k) 
  {
    super(page, k);
  }

  protected ElementContainer hiddens() 
  {
    return super.hiddens().
        addElement(hidden(CalParameter.KEYWORD_ID, k.getId())).
        addElement("\n");
  }

  protected String formFunction() 
  {
    return CalParameter.REPLACEKEYWORD_FUNC;
  }

  protected String titleText() 
  {
    return FormsDisplayText.EDIT_KEYWORD_TITLE;
  }

  protected String submitButtonText() 
  {
    return FormsDisplayText.CHANGE_KEYWORD;
  }
}
